#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "configure") {&configure;}
if ($q->param('fct') eq "save_conf") {&save_conf;}

####################################################################################

sub save_conf
{
$ver = $q->param('ver');
$numcheck = $q->param('numcheck');
$frames = $q->param('frames');
$timeout = $q->param('timeout');
$ssh = $q->param('ssh');

open (CFILE, "> $data_dir/crawler.cfg");
	print CFILE $ver . "\n";
	print CFILE $numcheck . "\n";
	print CFILE $frames . "\n";
	print CFILE $timeout . "\n";
	print CFILE $ssh . "\n";
close (CFILE);


$hbox = acs::get_heading_box("$web_url/ic_task.gif", "Configuration saved", qq[
<a href="$admin_url/admin44.cgi">Click Here to Continue.</a>
]); 



print <<END_OF_SAVED;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>

END_OF_SAVED

}






###################

sub configure
{

$cconf = acs::get_file_contents("$data_dir/crawler.cfg");  
($ver, $nr, $frames, $timeout, $ssh) = split (/\n/, $cconf);


if ($frames eq "") { $frames = 30; }
if ($timeout eq "") { $timeout = 30; }
if ($ssh eq "") { $ssh = 40; }


$hbox = acs::get_heading_box("$web_url/ic_task.gif", "Configure the Broken Link Checker", qq[
Choose options below.<BR>
<b><a href="$admin_url/admin44.cgi">Go Back</a></b>
]); 


print <<END_OF_CC;
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox




<form method="POST" action="$admin_url/admin44.cgi">
  <input type="hidden" name="fct" value="save_conf"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="45%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number of threads to open when
      checking links: </strong></td>
      <td width="55%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="frames" size="11"
       value="$frames"> <br>
      This is the amount of browser windows (frames) that will open to check for links. (via
      &lt;iframe&gt; tags). If you are not sure what this setting means then leave it at 10. <p>Note
      that using many threads may place a substancial load on the server. <strong>If you are on
      a shared host then keep this around 10 </strong></td>
    </tr>
    <tr>
      <td width="45%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Time Out value in seconds: </strong></td>
      <td width="55%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="timeout" size="11"
       value="$timeout"> <br>
      This is the amount of seconds the link checker will wait to connect to a URL to check if
      it exists. If a connection could not be made within this time frame then the link checker
      will not wait anymore for a connection and mark the link as faulty as a time-out error
      occurred. </td>
    </tr>
    <tr>
      <td width="45%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number of threads to open when
      checking links via SSH: </strong></td>
      <td width="55%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="ssh" size="11"
       value="$ssh"> <br>
      This is the amount of thread processes that will be created to check links. </td>
    </tr>
    <tr>
      <td width="45%" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="55%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="    Save    " name="B1"
      > </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>



<p>&nbsp;</p>
</body>
</html>

END_OF_CC

}







sub start
{

### CREATE brokenlnks2 IF THIS TABLE DOES NOT EXIST 

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$wsql = "SHOW TABLES";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
while ( @row = $sth->fetchrow() )
	{
	if ($row[0] eq "brokenlnks2") { $brokenlnk_tbl_found2 = "True"; }	
	}


if ($brokenlnk_tbl_found2 ne "True")
	{

	$sql = 			  "CREATE TABLE brokenlnks2
							(
							brid			int NOT NULL auto_increment,
							lnkid			int,
							cid			int,
							lnkproblem	varchar(255),
							problemid	varchar(255),

							PRIMARY 	KEY(brid)
							)  TYPE=MyISAM";

		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}	
	
	}
	
##################


$wsql = "SELECT count(*) FROM brokenlnks";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
while ( @row = $sth->fetchrow() ) { $b_users = $row[0]; }


$wsql = "SELECT count(*) FROM brokenlnks2";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
while ( @row = $sth->fetchrow() ) { $b_checker = $row[0]; }


if ($b_users < 1) { $b_users = 0; }
if ($b_checker < 1) { $b_checker = 0; }


$sth->finish;
$dbh->disconnect;




$cconf = acs::get_file_contents("$data_dir/crawler.cfg");  
($ver, $nr) = split (/\n/, $cconf);

if ($ver eq ""){$ver = 64;}
if ($ver == 64)
	{
	$linkchecker = "linkchecker.cgi";
	}
	else
	{
	$linkchecker = "linkchecker2.cgi";
	}

### ids


$hbox = acs::get_heading_box("$web_url/ic_task.gif", "Broken Link Checker", qq[
<table border="0" cellpadding="0" cellspacing="1" width="100%">
  <tr>
    <td width="88%" valign="top" class="normaltext">The Broken Link Checker checks for broken links residing in
    your Search Engine & Directory. </td>
    <td width="7%" align="right" valign="top" class="normaltext"><a
    href="$admin_url/help.cgi?fct=broken_lchecker" target="_blank"><strong><img
    src="$web_url/bhelps.gif" border="0"> </strong></a></td>
  </tr>
</table>
]);
 

print <<END_OF_START;
<html>
<head>
<title>PowerSeek</title>

<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  

<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(400,0);
      myWindow.focus();

    }
 // End Hide -->
 </script>

</head>

<body>

$hbox



<table border="0" cellspacing="1" width="100%" cellpadding="0" bgcolor="#DBDBDB"
height="437">
  <tr>
    <td height="30" colspan="2" background="$web_url/bar6.gif" bgcolor="#FFFFFF"
    class="normaltext"><strong>&nbsp; Choose an Option Below:</strong></td>
  </tr>
  <tr>
    <td width="1%" height="30" align="center" bgcolor="#FFFFFF" class="normaltext"><p
    align="center"><img src="$web_url/ic_brlnks.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext" valign="middle"><table
    border="0" cellpadding="6" cellspacing="1" width="100%">
      <tr>
        <td width="100%" class="normaltext"><strong><a href="$admin_url/linkchecker3.cgi">Check All Links Now </a><br>
        </strong>Click the check 'All Links' button below to check all the links residing in your
        directory &amp; search engine. <strong>Do not check for broken links in more than one
        browser window. </strong></td>
      </tr>
    </table>    </td>
  </tr>
  <tr>
    <td width="1%" height="30" align="center" bgcolor="#FFFFFF" class="normaltext"><p
    align="center"><img src="$web_url/add.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext" valign="middle"><table
    border="0" cellpadding="6" cellspacing="1" width="100%">
      <tr>
        <td width="100%"><form action="$admin_url/linkchecker3.cgi" method="POST" name="addu" class="normaltext">
          <input type="hidden" name="fct" value="catcheck"><p><strong>Only Check Links in Specific Categories: (Specify Category Ids) <br>
          </strong><input type="text" name="ids" size="70"
          style="font-family: MS Sans Serif; font-size: 8"> <input type="submit" value="Check Now"
          name="add" style="font-family: MS Sans Serif; font-size: 8pt"> <a
          href="$admin_url/admin67.cgi?fct=related&amp;linkchk=true"
          onClick="popup('$admin_url/admin67.cgi?fct=related&amp;linkchk=true',800,600);return false;">Browser
          </a><br>
          Examples of what you could specify above: <strong>343,42,3,1 - </strong>Please specify
          category IDs above where links resides in, to check for broken links in specific
          categories. Separate the category IDs via comma's. You can get category IDs or assign
          category IDs by clicking the 'Browser' button above. <br><strong>Broken links will be
          reported in the <a href="$admin_url/admin58.cgi?fct=lchecker">Broken Links Management
          Utility </a>. </strong></p>
        </form>        </td>
      </tr>
    </table>    </td>
  </tr>
  <tr>
    <td width="1%" height="30" align="center" bgcolor="#FFFFFF" class="normaltext"><img
    src="$web_url/ic_dirs.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext" valign="middle"><table
    border="0" cellpadding="6" cellspacing="1" width="100%">
      <tr>
        <td width="100%" class="normaltext"><strong><a href="$admin_url/admin58.cgi?fct=lchecker">Manage Broken Links
        found by Link Checker </a>($b_checker) <br>
        </strong>Manage all reported broken links. All reports of broken links can be found in
        here. </td>
      </tr>
    </table>    </td>
  </tr>
  <tr>
    <td height="30" align="center" bgcolor="#FFFFFF" class="normaltext"><p
    align="center"><img src="$web_url/ic_users.gif"> </td>
    <td height="80" bgcolor="#FFFFFF" class="normaltext" valign="middle"><table
    border="0" cellpadding="6" cellspacing="1" width="100%">
        <tr>
          <td width="100%" class="normaltext"><strong><a href="$admin_url/admin58.cgi?fct=users">Manage Broken Links
            Reported by Visitors </a>($b_users) <br>
            </strong>Manage all reported broken links. All reports of broken links can be found in
            here. </td>
        </tr>
    </table></td>
  </tr>
  <tr>
    <td height="30" align="center" bgcolor="#FFFFFF" class="normaltext"><p
    align="center"><img src="$web_url/ic_settings3.gif"></td>
    <td height="80" bgcolor="#FFFFFF" class="normaltext" valign="middle"><table
    border="0" cellpadding="6" cellspacing="1" width="100%">
        <tr>
          <td width="100%" class="normaltext"><a href="$admin_url/admin44.cgi?fct=configure"><strong>Configure the Link
            Checker </strong></a><br>
            If you get <strong>'Internet Server Errors' </strong>or other <strong>errors </strong>when
            trying to check links, please click the above link to configure the link checker so that
            it will work on your host. </td>
        </tr>
    </table></td>
  </tr>
</table>


<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>
</body>
</html>

END_OF_START



}






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

